--
-- Fran lifted 2D transformations
-- 
-- Last modified Thu Nov 07 14:34:10 1996

module Transform2B(
	Transform2B,
	(*%), translate2, scale2,
	identity2, compose2, inverse2,
	rotate2, uscale2,               
        Transform2, Translateable2, Transformable2, Scaleable2,
	) where

import qualified Transform2 as T
import Transform2(Transform2, Translateable2, Transformable2, Scaleable2)
import Fuzzy
import Behavior
import BaseTypes
	
-- Hugs bug (?) workaround.  See comment in VectorSpaceB.
-- infixr 7 *%, `compose2`         -- transform apply and compose

type Transform2B = Behavior Transform2

identity2  :: Transform2B
rotate2    :: Behavior RealVal -> Transform2B
compose2   :: Transform2B -> Transform2B -> Transform2B
inverse2   :: Transform2B -> Transform2B
translate2 :: Translateable2 a => Behavior a -> Transform2B
scale2     :: Scaleable2 a => Behavior a -> Transform2B
uscale2    :: Behavior RealVal -> Transform2B
(*%)       :: Transformable2 a => Transform2B -> Behavior a -> Behavior a

identity2  = lift0 T.identity2
rotate2    = lift1 T.rotate2 (noI "rotate2")
compose2   = lift2 T.compose2 (noI "compose2 ")
inverse2   = lift1 T.inverse2 (noI "inverse2")
uscale2    = lift1 T.uscale2 (noI "uscale2")

translate2 =  lift1 T.translate2 (noI "translate2")

scale2 =  lift1 T.scale2 (noI "scale2")

(*%) =  lift2 (T.*%) (noI "*%")

