--
-- Fran lifted vector spaces
-- 
-- Last modified Sun Nov 10 16:15:46 1996

module VectorSpaceB( 
             zeroVector, (*^), (*^), (^/), (^+^), (^-^), (^+^), (^-^),
             dot, magnitude, magnitudeSquared, normalize,
             VectorSpace ) where

import Fuzzy
import Behavior
import qualified VectorSpace as VS
import VectorSpace(VectorSpace)

-- The behavioral vectorspace operators use the same names as the
-- non-behavioral definitions in VectorSpace.  One of these modules must
-- be qualified if both are imported.

-- I think the following should be here, but they cause Hugs to claim that
-- we're redefining the syntax of these operators, even though the
-- importation is done qualified.  Is this a Hugs bug??  If so, be sure to
-- restore the infix declarations below when the bug is fixed.

-- infixr 7 *^, ^/, `dot`
-- infixl 6 ^+^, ^-^

zeroVector :: VectorSpace v => Behavior v
zeroVector  = lift0 VS.zeroVector

(*^) :: VectorSpace v => ScalarB
                  -> Behavior v -> Behavior v
(*^) = lift2 (VS.*^) (noI "(*^)")

(^/) :: VectorSpace v => Behavior v ->
           ScalarB -> Behavior v
(^/) = lift2 (VS.^/) (noI "(^/)")

(^+^),(^-^) :: VectorSpace v => Behavior v
                  -> Behavior v -> Behavior v
(^+^) = lift2 (VS.^+^) (noI "(^+^)")
(^-^) = lift2 (VS.^-^) (noI "(^-^)")

dot :: VectorSpace v => Behavior v
                  -> Behavior v -> ScalarB
dot = lift2 VS.dot (noI "dot")

magnitude, magnitudeSquared
   :: VectorSpace v => Behavior v -> ScalarB
magnitudeSquared = lift1 VS.magnitudeSquared (noI "magnitudeSquared")
magnitude        = lift1 VS.magnitude (noI "magnitude")

normalize :: VectorSpace v => Behavior v -> Behavior v
normalize = lift1 VS.normalize (noI "normalize")
