module GraphicsTypes
	( Angle
	, Dimension, toDimension, fromDimension
	, Point,     toPoint,     fromPoint
	, RGB(RGB)
	, Picture
	) where

import qualified Win32

-- Hugs does not allow operators to have different fixities in 
-- different modules (this is a known deviation from Standard Haskell).
-- In consequence, we don't declare any fixities in any non-standard
-- library because it would prevent the programmer from using the same
-- operator name at a different fixity.
--
-- infixr 9 `over`

----------------------------------------------------------------
-- Units
----------------------------------------------------------------

type Angle     = Double

type Dimension = Int
type Point     = (Dimension,Dimension)

-- These functions are used when implementing Pictures
toPoint        :: Win32.POINT -> Point
fromPoint      :: Point -> Win32.POINT

toDimension    :: Win32.INT -> Dimension
fromDimension  :: Dimension -> Win32.INT

toPoint         = id
fromPoint       = id
toDimension     = id
fromDimension   = id

---------------------------------------------------------------
-- Colors
----------------------------------------------------------------

data RGB = RGB Int Int Int

----------------------------------------------------------------
-- Pictures
----------------------------------------------------------------

type Picture = Win32.HDC -> IO ()

----------------------------------------------------------------
