################################################################
# Win32 plugin
#
# Copyright (c) The University of Nottingham and Yale University, 1994-1997.
# All rights reserved. See NOTICE for details and conditions of use etc...
# Hugs version 1.4, March 1997
#
# $RCSfile: Win32.ss,v $
# $Revision: 1.6 $
# $Date: 1997/03/25 19:43:56 $
################################################################

{%
#include "HUGS.h"
#undef ERROR

/* We define OEMRESOURCE so that we can get the OBM_ constants */
#define OEMRESOURCE
#include <windows.h>
%}


{{%
module Win32 where
import Prelude hiding (readFile, writeFile)
%}}

%include StdTypes.ss
%include Pointers.ss
%include BitSet.ss
%include WinPlatform.ss
%include WinStrings.ss

################################################################
# Inclusions
################################################################

%include Windows.ss
%include WinMenu.ss
%include WinGDI.ss
%include WinBitmap.ss
%include WinFonts.ss
%include WinFiles.ss
%include WinRegistry.ss
%include WinMIDI.ss
%include WinCommDlg.ss
%include WinMisc.ss

################################################################
# Fast, rotatable ellipse hack
################################################################

# Draw an ellipse which fits within the specified parallelogram.
# (This is equivalent to drawing a scaled, rotated, transformed ellipse).
#
# You can't rotate an ellipse - so we draw polygons instead.
# We lazily calculate an array of sin-cosine pairs.

{%
#include <math.h>
#define SIN_Cache_Size 20

Bool TransformedEllipse(HDC hdc, POINT p0, POINT p1, POINT p2)
{
  static Bool firstTime = 1;
  static double sins[SIN_Cache_Size];
  static double coss[SIN_Cache_Size];

  int   i;
  POINT pts[SIN_Cache_Size];

  Double x = (p1.x + p2.x) / 2;  /* centre of parallelogram */
  Double y = (p1.y + p2.y) / 2;

  Double dx1 = (p1.x - p0.x) / 2; /* distance to corners from centre */
  Double dy1 = (p1.y - p0.y) / 2;
  Double dx2 = (p2.x - p0.x) / 2;
  Double dy2 = (p2.y - p0.y) / 2;

  if (firstTime) {
    double a  = 0.0;
    double da = 2.0*3.14159 / SIN_Cache_Size;
    for (i=0; i < SIN_Cache_Size; ++i, a+=da) {
       sins[i] = sin(a);
       coss[i] = cos(a);
    }
    firstTime = 0;
  }
  for(i=0; i < SIN_Cache_Size; ++i) {
    double c = coss[i];
    double s = sins[i];
    pts[i].x = x + c*dx1 + s*dx2;
    pts[i].y = y + c*dy1 + s*dy2;
  }
  return Polygon(hdc,pts,SIN_Cache_Size);
}

#undef SIN_Cache_Size
%}

%errfun False TransformedEllipse :: HDC -> POINT -> POINT -> POINT -> IO ()

################################################################
# End of Win32.ss
################################################################

