################################################################
# Bitmaps
################################################################

# ToDo: many more bitmap operations

# %pack : Bitmap
# ...
#
# %unpack : Bitmap : void* $0
# ...
#
# ToDo: this is no use for creating uninitialised bitmaps
# %prim createBitmap :: UINT -> UINT -> Bitmap -> IO MbHBITMAP
# MbHBITMAP r = CreateBitmap($2_width,$2_height,$0,$1,&$2);
# %return(r);

################################################################
# Standard bitmap resource IDs
################################################################

%const Bitmap OBM_CLOSE          = MAKEINTRESOURCE(OBM_CLOSE)
%const Bitmap OBM_UPARROW        = MAKEINTRESOURCE(OBM_UPARROW)
%const Bitmap OBM_DNARROW        = MAKEINTRESOURCE(OBM_DNARROW)
%const Bitmap OBM_RGARROW        = MAKEINTRESOURCE(OBM_RGARROW)
%const Bitmap OBM_LFARROW        = MAKEINTRESOURCE(OBM_LFARROW)
%const Bitmap OBM_REDUCE         = MAKEINTRESOURCE(OBM_REDUCE)
%const Bitmap OBM_ZOOM           = MAKEINTRESOURCE(OBM_ZOOM)
%const Bitmap OBM_RESTORE        = MAKEINTRESOURCE(OBM_RESTORE)
%const Bitmap OBM_REDUCED        = MAKEINTRESOURCE(OBM_REDUCED)
%const Bitmap OBM_ZOOMD          = MAKEINTRESOURCE(OBM_ZOOMD)
%const Bitmap OBM_RESTORED       = MAKEINTRESOURCE(OBM_RESTORED)
%const Bitmap OBM_UPARROWD       = MAKEINTRESOURCE(OBM_UPARROWD)
%const Bitmap OBM_DNARROWD       = MAKEINTRESOURCE(OBM_DNARROWD)
%const Bitmap OBM_RGARROWD       = MAKEINTRESOURCE(OBM_RGARROWD)
%const Bitmap OBM_LFARROWD       = MAKEINTRESOURCE(OBM_LFARROWD)
%const Bitmap OBM_MNARROW        = MAKEINTRESOURCE(OBM_MNARROW)
%const Bitmap OBM_COMBO          = MAKEINTRESOURCE(OBM_COMBO)
%const Bitmap OBM_UPARROWI       = MAKEINTRESOURCE(OBM_UPARROWI)
%const Bitmap OBM_DNARROWI       = MAKEINTRESOURCE(OBM_DNARROWI)
%const Bitmap OBM_RGARROWI       = MAKEINTRESOURCE(OBM_RGARROWI)
%const Bitmap OBM_LFARROWI       = MAKEINTRESOURCE(OBM_LFARROWI)
%const Bitmap OBM_OLD_CLOSE      = MAKEINTRESOURCE(OBM_OLD_CLOSE)
%const Bitmap OBM_SIZE           = MAKEINTRESOURCE(OBM_SIZE)
%const Bitmap OBM_OLD_UPARROW    = MAKEINTRESOURCE(OBM_OLD_UPARROW)
%const Bitmap OBM_OLD_DNARROW    = MAKEINTRESOURCE(OBM_OLD_DNARROW)
%const Bitmap OBM_OLD_RGARROW    = MAKEINTRESOURCE(OBM_OLD_RGARROW)
%const Bitmap OBM_OLD_LFARROW    = MAKEINTRESOURCE(OBM_OLD_LFARROW)
%const Bitmap OBM_BTSIZE         = MAKEINTRESOURCE(OBM_BTSIZE)
%const Bitmap OBM_CHECK          = MAKEINTRESOURCE(OBM_CHECK)
%const Bitmap OBM_CHECKBOXES     = MAKEINTRESOURCE(OBM_CHECKBOXES)
%const Bitmap OBM_BTNCORNERS     = MAKEINTRESOURCE(OBM_BTNCORNERS)
%const Bitmap OBM_OLD_REDUCE     = MAKEINTRESOURCE(OBM_OLD_REDUCE)
%const Bitmap OBM_OLD_ZOOM       = MAKEINTRESOURCE(OBM_OLD_ZOOM)
%const Bitmap OBM_OLD_RESTORE    = MAKEINTRESOURCE(OBM_OLD_RESTORE)

################################################################
#
################################################################

%errfun NullHANDLE CreateCompatibleBitmap :: HDC -> INT -> INT -> IO HBITMAP

%newtype : RasterOp3 : DWORD : ()

# There's a bunch of common RasterOps defined in "windows.h"
# but if you know what you're doing, you can construct them out
# of Hex numbers yourself.

%prim mkRasterOp3 :: DWORD -> RasterOp3
%return($0);

# Ternary raster operations 
%const RasterOp3 SRCCOPY             
%const RasterOp3 SRCPAINT            
%const RasterOp3 SRCAND              
%const RasterOp3 SRCINVERT           
%const RasterOp3 SRCERASE            
%const RasterOp3 NOTSRCCOPY          
%const RasterOp3 NOTSRCERASE         
%const RasterOp3 MERGECOPY           
%const RasterOp3 MERGEPAINT          
%const RasterOp3 PATCOPY             
%const RasterOp3 PATPAINT            
%const RasterOp3 PATINVERT           
%const RasterOp3 DSTINVERT           
%const RasterOp3 BLACKNESS           
%const RasterOp3 WHITENESS           

%errfun False BitBlt :: HDC -> INT -> INT -> INT -> INT -> HDC -> INT -> INT -> RasterOp3 -> IO ()

%newtype : RasterOp4 : DWORD : ()

%fun MAKEROP4 :: RasterOp3 -> RasterOp3 -> RasterOp4

%errfun False MaskBlt :: HDC -> INT -> INT -> INT -> INT -> HDC -> INT -> INT -> HBITMAP -> INT -> INT -> RasterOp4 -> IO ()

%errfun False StretchBlt :: HDC -> INT -> INT -> INT -> INT -> HDC -> INT -> INT -> INT -> INT -> RasterOp3 -> IO ()

%errfun False PatBlt :: HDC -> INT -> INT -> INT -> INT -> RasterOp3 -> IO ()

%prim plgBlt :: HDC -> POINT -> POINT -> POINT -> HDC -> INT -> INT -> INT -> INT -> MbHBITMAP -> INT -> INT -> IO ()
POINT vertices[3];
Bool r;
vertices[0] = $1;
vertices[1] = $2;
vertices[2] = $3;
r = PlgBlt($0,vertices,$4,$5,$6,$7,$8,$9,$10,$11);
%errreturn(False,r);

# These functions manipulate slots in the bitmap which are ignored by
# Windows - but may be used by applications.

%errfun False getBitmapDimensionEx :: HBITMAP ->         IO SIZE using $err = GetBitmapDimensionEx($0, &$r0)
%errfun False setBitmapDimensionEx :: HBITMAP -> SIZE -> IO SIZE using $err = SetBitmapDimensionEx($0, $1.cx, $1.cy, &$r0)


################ Bitmap representation ################

################ BITMAPCOREINFO ################

# Should work - but I'm getting unresolved symbols when I compile it

# %struct : RGBTRIPLE
#     BYTE    : rgbtBlue
#     BYTE    : rgbtGreen
#     BYTE    : rgbtRed
# 
# %ptr : LPRGBTRIPLE : RGBTRIPLE
# 
# %struct : BITMAPCOREHEADER
#     DWORD   : bcSize     # sizeofLPBITMAPCOREHEADER
#     WORD    : bcWidth
#     WORD    : bcHeight
#     WORD    : bcPlanes   # 1
#     WORD    : bcBitCount # 1, 4, 8 or 24
# 
# %ptr : LPBITMAPCOREHEADER : BITMAPCOREHEADER
# 
# %struct : BITMAPCOREINFO
#     BITMAPCOREHEADER : bmciHeader
# # last field omitted - use bmciColors function
# 
# %ptr : LPBITMAPCOREINFO : BITMAPCOREINFO
# 
# %prim bmciColors :: LPBITMAPCOREINFO -> LPRGBTRIPLE
# %return(&($0->bmciColors));


################ 

%struct : RGBQUAD
    BYTE    : rgbBlue
    BYTE    : rgbGreen
    BYTE    : rgbRed
    BYTE    : rgbReserved

%ptr : LPRGBQUAD   : RGBQUAD

################ BITMAP ################

%struct : BITMAP
    LONG    : bmType
    LONG    : bmWidth
    LONG    : bmHeight
    LONG    : bmWidthBytes
    WORD    : bmPlanes
    WORD    : bmBitsPixel
# last field omitted - use bmBits function

%ptr : LPBITMAP : BITMAP

%prim bmBits :: LPBITMAP -> LPVOID
%return(&($0->bmBits));

%prim getBitmapInfo :: HBITMAP -> IO BITMAP
BITMAP bm;
int r = GetObject($0, sizeof(BITMAP), &bm);
%errreturn(Zero,r,bm);


################ BITMAPINFO ################

%newtype : BitmapCompression : DWORD : (Eq)

%const BitmapCompression BI_RGB  
%const BitmapCompression BI_RLE8 
%const BitmapCompression BI_RLE4 
%const BitmapCompression BI_BITFIELDS

%struct : BITMAPINFOHEADER
    DWORD   : biSize      # sizeofBITMAPINFOHEADER
    LONG    : biWidth
    LONG    : biHeight
    WORD    : biPlanes
    WORD    : biBitCount  # 1, 4, 8, 16, 24 or 32
    BitmapCompression   : biCompression
    DWORD   : biSizeImage
    LONG    : biXPelsPerMeter
    LONG    : biYPelsPerMeter
    MbDWORD : biClrUsed
    MbDWORD : biClrImportant  

%ptr : LPBITMAPINFOHEADER : BITMAPINFOHEADER

%struct : BITMAPINFO
  BITMAPINFOHEADER : bmiHeader
# last field omitted - use bmiColors function

%ptr : LPBITMAPINFO : BITMAPINFO

%prim bmiColors :: LPBITMAPINFO -> LPRGBQUAD
%return(&($0->bmiColors));


################ BITMAPFILEHEADER ################

%struct : BITMAPFILEHEADER
    UINT    : bfType      # "BM" == 0x4d42
    DWORD   : bfSize      # number of words in file (== length file / 4)
    UINT    : bfReserved1 # == 0
    UINT    : bfReserved2 # == 0
    DWORD   : bfOffBits   # == (char*) bits - (char*) filehdr

%ptr : LPBITMAPFILEHEADER : BITMAPFILEHEADER


################ Functions to create/manipulate bitmap data ################

%errfun NullHANDLE CreateBitmap :: INT -> INT -> UINT -> UINT -> MbLPVOID -> IO HBITMAP

# ToDo: would BITMAP be more convenient than LPBITMAP?
%errfun NullHANDLE CreateBitmapIndirect :: LPBITMAP -> IO HBITMAP


%synonym : ColorFormat : UINT : (Eq)

%const ColorFormat DIB_PAL_COLORS
%const ColorFormat DIB_RGB_COLORS

%errfun Zero GetDIBits :: HDC -> HBITMAP -> UINT -> UINT -> MbLPVOID -> LPBITMAPINFO -> ColorFormat -> IO INT


%errfun Zero SetDIBits :: HDC -> HBITMAP -> UINT -> UINT -> LPVOID -> LPBITMAPINFO -> ColorFormat -> IO INT

# ToDo: Should these return lists of RGBQUADs??
%errfun Zero SetDIBColorTable :: HDC -> UINT -> UINT -> LPRGBQUAD -> IO UINT
%errfun Zero GetDIBColorTable :: HDC -> UINT -> UINT -> LPRGBQUAD -> IO UINT

# ToDo: invent a type for this thing?
%const DWORD CBM_INIT

%errfun NullHANDLE CreateDIBitmap :: HDC -> LPBITMAPINFOHEADER -> DWORD -> LPVOID -> LPBITMAPINFO -> ColorFormat -> IO HBITMAP

# ToDo: not a very informative type!
%errfun NullHANDLE CreateDIBPatternBrushPt :: LPVOID -> ColorFormat -> IO HBRUSH
%errfun NullHANDLE CreateDIBSection :: HDC -> LPBITMAPINFO -> ColorFormat -> MbHANDLE -> DWORD -> IO (HBITMAP, LPVOID) using $r0 = CreateDIBSection($0,$1,$2,&$r1,$3,$4);
%errfun Zero       SetDIBitsToDevice :: HDC -> INT -> INT -> DWORD -> DWORD -> INT -> INT -> UINT -> UINT -> LPVOID -> LPBITMAPINFO -> ColorFormat -> IO INT
%errfun GDI_ERROR  StretchDIBits :: HDC -> INT -> INT -> INT -> INT -> INT -> INT -> INT -> INT -> LPVOID -> LPBITMAPINFO -> ColorFormat -> RasterOp3 -> IO INT


################ StretchBltMode ################

%synonym : StretchBltMode : INT : (Eq)

%maybe : MbStretchBltMode : StretchBltMode : $0 : 0

%const StretchBltMode BLACKONWHITE    
%const StretchBltMode WHITEONBLACK    
%const StretchBltMode COLORONCOLOR    
%const StretchBltMode HALFTONE

# Newer (and allegedly simpler) names
%const StretchBltMode STRETCH_ANDSCANS    # == BLACKONWHITE
%const StretchBltMode STRETCH_ORSCANS     # == WHITEONBLACK
%const StretchBltMode STRETCH_DELETESCANS # == COLORONCOLOR

# Don't forget to call SetBrushOrdEx after setting HALFTONE mode
%errfun Zero SetStretchBltMode :: HDC -> StretchBltMode -> IO StretchBltMode
%errfun Zero GetStretchBltMode :: HDC -> IO StretchBltMode


